- Main Page
- Classes
- Files
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# sc::RefBase Class Reference

Provides a few utility routines common to all Ref template instantiations. More...

`#include <ref.h>`

Inheritance diagram for sc::RefBase:

List of all members.

## Public Member Functions
virtual RefCount * | parentpointer () const=0
| Returns the DescribedClass pointer for the contained object.
void | require_nonnull () const
| Requires that a nonnull reference is held.
## Protected Member Functions
void | warn (const char *msg) const
| Print a warning message.
void | warn_ref_to_stack () const
| Called when stack data is referenced.
void | warn_skip_stack_delete () const
| Called when the deletion of stack data is skipped.
void | warn_bad_ref_count () const
| Called when the reference count is corrupted.
void | ref_info (RefCount *p, std::ostream &os) const
| Print information about the reference.
void | ref_info (std::ostream &os) const
void | check_pointer () const
void | reference (RefCount *)
int | dereference (RefCount *)

## Detailed Description

Provides a few utility routines common to all Ref template instantiations.

## Member Function Documentation

void sc::RefBase::require_nonnull | ( |  | ) | const

Requires that a nonnull reference is held.

If not, the program will abort.

The documentation for this class was generated from the following file:

- ref.h